import { HttpClient } from "@angular/common/http";
import {Observable} from "rxjs/Rx";
import { Injectable } from '@angular/core';
import {SERVER_API_URL_coms} from "../app.constants";
import {CommonService} from '../shared/common/common.service';

@Injectable()
export class SystemService {

    constructor(private http: HttpClient,private commonSer:CommonService) {
    }

    //角色列表
    role(): Observable<any>{
        return this.http.get(SERVER_API_URL_coms + '/role/getAllRole');
    }

    //获取单个角色
    getRole(params): Observable<any>{
        return this.http.get(SERVER_API_URL_coms + '/role/'+ params);
    }

    //编辑角色
    editRole(data): Observable<any>{
        return this.http.post(SERVER_API_URL_coms + '/role/updateRole',data);
    }

    //新增角色
    addRole(data): Observable<any>{
        return this.http.post(SERVER_API_URL_coms + '/role/createRole',data);
    }

    //删除用户
    deleteRole(params): Observable<any>{
        return this.http.get(SERVER_API_URL_coms + '/role/deleteRoleById?' +this.commonSer.toQuery(params));
    }

    //用户列表
    user(data): Observable<any>{
        return this.http.post(SERVER_API_URL_coms + '/user/findUsers',data);
    }

    //新增用户
    adduser(data): Observable<any>{
        return this.http.post(SERVER_API_URL_coms + '/user',data);
    }

    //删除用户
    deleteUser(params){
        return this.http.delete(SERVER_API_URL_coms + '/user/'+ params);
    }

    //组织结构列表  /organization/updateOrganization
    organization(): Observable<any>{
        return this.http.get(SERVER_API_URL_coms + '/organization/getAll',);
    }

    //编辑组织
    updateOrganization(): Observable<any>{
        return this.http.get(SERVER_API_URL_coms + '/organization/updateOrganization',);
    }

    //创建组织结构
    createOrg(data): Observable<any>{
        return this.http.post(SERVER_API_URL_coms + '/organization/createOrganization',data);
    }

    //三员分立列表
    getSeparationConfig(): Observable<any>{
        return this.http.get(SERVER_API_URL_coms + '/separationConfig/getSeparationConfig',);
    }

    //审计列表
    logList(data): Observable<any>{
        return this.http.get(SERVER_API_URL_coms + '/log?'+this.commonSer.toQuery(data));
    }

    //对单一角色批量添加用户
    batchGrantUserToRole(data): Observable<any>{
        return this.http.post(SERVER_API_URL_coms + '/role/batchGrantUserToRole',data);
    }

    //对单一用户批量授权角色
    batchGrantRoleToUser(data): Observable<any>{
        return this.http.post(SERVER_API_URL_coms + '/role/batchGrantRoleToUser',data);
    }

    //查询三员分立是否开启
    separationPowerStatus(): Observable<any>{
        return this.http.get(SERVER_API_URL_coms + '/approval/separationPowerStatus');
    }

    //修改三员分立状态
    updateValue(data): Observable<any>{
        return this.http.post(SERVER_API_URL_coms + '/separationConfig/updateValue',data);
    }

    //获取当前登录人角色
    currentUserRoles(): Observable<any>{
        return this.http.get(SERVER_API_URL_coms + '/role/currentUserRoles');
    }

    //单个用户角色获取
    roleList(data): Observable<any>{
        return this.http.get(SERVER_API_URL_coms + '/user/roleList?'+this.commonSer.toQuery(data) );
    }

    //获取当前安全管理员已审批记录
    approveListSafeManager(data): Observable<any>{
        return this.http.get(SERVER_API_URL_coms + '/approval/approveListSafeManager?'+this.commonSer.toQuery(data) );
    }

    //获取当前安全管理员未审批记录
    unapproveListSafeManager(data): Observable<any>{
        return this.http.get(SERVER_API_URL_coms + '/approval/unapproveListSafeManager?'+this.commonSer.toQuery(data) );
    }

    //获取当前系统管理员的已审批记录
    approveListSystemManager(data): Observable<any>{
        return this.http.get(SERVER_API_URL_coms + '/approval/approveListSystemManager?'+this.commonSer.toQuery(data) );
    }

    //获取当前系统管理员的未审批记录
    unApproveListSystemManager(data): Observable<any>{
        return this.http.get(SERVER_API_URL_coms + '/approval/unApproveListSystemManager?'+this.commonSer.toQuery(data) );
    }

    //批量审批通过
    approvalPass(data): Observable<any>{
        return this.http.post(SERVER_API_URL_coms + '/approval/pass', data);
    }

    //批量审批退回
    approvalReject(data): Observable<any>{
        return this.http.post(SERVER_API_URL_coms + '/approval/reject', data);
    }

    //批量撤回审批
    approvalRemove(data): Observable<any>{
        return this.http.post(SERVER_API_URL_coms + '/approval/remove', data);
    }

    approveList(): Observable<any>{
        return this.http.get(SERVER_API_URL_coms + '/approval/approveList');
    }

    unApproveList(): Observable<any>{
        return this.http.get(SERVER_API_URL_coms + '/approval/unApproveList' );
    }

    //修改密码
    modifyPassword(data): Observable<any>{
        return this.http.post(SERVER_API_URL_coms + '/modifyPassword',data );
    }
}
